<?php

namespace app\admin\controller\greenroom;

use app\admin\model\Admin;
use app\common\controller\Backend;
use think\Db;
use think\exception\PDOException;
use think\exception\ValidateException;

/**
 * 用户代理记录
 *
 * @icon fa fa-circle-o
 */
class Agent extends Backend
{

    /**
     * Agent模型对象
     * @var \app\admin\model\greenroom\Agent
     */
    protected $model = null;

    public function _initialize()
    {


        parent::_initialize();
        $this->model = new \app\admin\model\greenroom\Agent;
        $this->rechargeModel= new \app\admin\model\greenroom\Recharge;
        $this->usercodeModel= new \app\admin\model\greenroom\Usercode;
        $this->dataList = $this->rechargeModel->select();
        foreach ($this->dataList as $k => &$v) {
            $data[$v['id']] = $v['level'];
        }

        $this->view->assign('level', $data);
        $this->adminmodel = new \app\admin\model\Admin;
        $admindata = Admin::field('id,nickname')->select();
        $temp=[];
        foreach ($admindata as $key=>$val){
            $temp[$val['id']]=$val['nickname'];

        }
        $this->admindata=$temp;
        $statusList=[0=>'审核中',1=>'已通过',2=>'未通过'];
        $this->view->assign('statusList', $statusList);
        $this->view->assign('userlist', $this->admindata);
    }



    /**
     * 默认生成的控制器所继承的父类中有index/add/edit/del/multi五个基础方法、destroy/restore/recyclebin三个回收站方法
     * 因此在当前控制器中可不用编写增删改查的代码,除非需要自己控制这部分逻辑
     * 需要将application/admin/library/traits/Backend.php中对应的方法复制到当前控制器,然后进行修改
     */


    /**
     * 查看
     */
    public function index()
    {
        //当前是否为关联查询
        $this->relationSearch = true;
        //设置过滤方法
        $this->request->filter(['strip_tags', 'trim']);
        if ($this->request->isAjax()) {
            //如果发送的来源是Selectpage，则转发到Selectpage
            if ($this->request->request('keyField')) {
                return $this->selectpage();
            }
            list($where, $sort, $order, $offset, $limit) = $this->buildparams();

            $list = $this->model
                    ->with(['admin','recharge'])
                    ->where($where)
                    ->order($sort, $order)
                    ->paginate($limit);

            foreach ($list as $row) {
                
                $row->getRelation('admin')->visible(['username','appname']);
				$row->getRelation('recharge')->visible(['level']);
            }

            $result = array("total" => $list->total(), "rows" => $list->items());

            return json($result);
        }
        return $this->view->fetch();
    }

    public function edit($ids = null)
    {
        $row = $this->model->get($ids);
        if (!$row) {
            $this->error(__('No Results were found'));
        }
        $adminIds = $this->getDataLimitAdminIds();
        if (is_array($adminIds) && !in_array($row[$this->dataLimitField], $adminIds)) {
            $this->error(__('You have no permission'));
        }
        if (false === $this->request->isPost()) {
            $this->view->assign('row', $row);
            return $this->view->fetch();
        }
        $params = $this->request->post('row/a');
        if (empty($params)) {
            $this->error(__('Parameter %s can not be empty', ''));
        }
        $params = $this->preExcludeFields($params);
        $result = false;
        Db::startTrans();
        try {
            //是否采用模型验证
            if ($this->modelValidate) {
                $name = str_replace("\\model\\", "\\validate\\", get_class($this->model));
                $validate = is_bool($this->modelValidate) ? ($this->modelSceneValidate ? $name . '.edit' : $name) : $this->modelValidate;
                $row->validateFailException()->validate($validate);
            }
            if($params['status']==1&&$row->is_code===0)
            {
                $recharge  =  $this->rechargeModel->find($params['r_id']);
                if($recharge){
                    $codes = build_code($recharge->codenum);

                    $nowtime= time();
                    $uscodes=[];
                  foreach ($codes as $key=>$val){
                      $uscodes[]=['code'=>$val,
                          'paydays'=>30,
                          'agent_id'=>$row->uid,
                          'addtime'=>$nowtime,
                          'status'=>1 ];
                  }

                    $this->usercodeModel->saveAll($uscodes,true);
                    $params['is_code']=1;
                }
            }
            $result = $row->allowField(true)->save($params);
            Db::commit();
        } catch (ValidateException|PDOException|Exception $e) {
            Db::rollback();
            $this->error($e->getMessage());
        }
        if (false === $result) {
            $this->error(__('No rows were updated'));
        }
        $this->success();
    }

}
